# class Crystal::Macros::Case

- Crystal::Macros::Case
- Crystal::Macros::ASTNode

##
Overview

A `case` expression.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #cond : ASTNode

  Returns the condition (target) of this `case`.

- #else : ASTNode

  Returns the `#else` of this `case`.

- #exhaustive? : BoolLiteral

  Returns whether this `case` is exhaustive (`case ...

- #whens : ArrayLiteral(When)

  Returns the `when`s of this `case`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def cond : ASTNode #

Returns the condition (target) of this `case`.

def else : ASTNode #

Returns the `#else` of this `case`.

def exhaustive? : BoolLiteral #

Returns whether this `case` is exhaustive (`case ... in`).

def whens : ArrayLiteral(When) #

Returns the `when`s of this `case`.